﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title></title>
    <style type="text/css">
        .tableClass
        {
            width: 200px;
            float: left;
        }
    </style>
</head>
<body>
    <form id="form1" runat="server">
    <asp:ScriptManager ID="ScriptManager1" runat="server">
    </asp:ScriptManager>
    <telerik:RadDockLayout ID="RadDockLayout1" runat="server">
        <table class="tableClass">
            <tbody>
                <tr>
                    <td>
                        <telerik:RadDockZone ID="RadDockZone1" runat="server" MinHeight="300px" Width="300px">
                            <telerik:RadDock ID="RadDock1" runat="server" Width="300px" Title="raddock1" OnClientDragStart="OnClientDragStart"
                                DockMode="Docked" ForbiddenZones="RadDockZone2">
                                <ContentTemplate>
                                    <br />
                                    <br />
                                    drag 1
                                    <br />
                                    <br />
                                </ContentTemplate>
                            </telerik:RadDock>
                        </telerik:RadDockZone>
                        <telerik:RadDockZone ID="RadDockZone2" runat="server" MinHeight="300px" Width="300px">
                            <telerik:RadDock ID="RadDock2" runat="server" Width="300px" Title="RADDOCK1" OnClientDragStart="OnClientDragStart"
                                ForbiddenZones="RadDockZone1" DockMode="Docked">
                                <ContentTemplate>
                                    <br />
                                    <br />
                                    DRAG 2
                                    <br />
                                    <br />
                                </ContentTemplate>
                            </telerik:RadDock>
                        </telerik:RadDockZone>
                    </td>
                </tr>
            </tbody>
        </table>
        <table style="float: left;">
            <tr>
                <td>
                    <telerik:RadDockZone ID="RadDockZone3" runat="server" MinHeight="300px" Width="300px">
                    </telerik:RadDockZone>
                </td>
                <td>
                    <telerik:RadDockZone ID="RadDockZone4" runat="server" MinHeight="300px" Width="300px">
                    </telerik:RadDockZone>
                </td>
                <td>
                    <telerik:RadDockZone ID="RadDockZone5" runat="server" MinHeight="300px" Width="300px">
                    </telerik:RadDockZone>
                </td>
            </tr>
        </table>
    </telerik:RadDockLayout>

    <script type="text/javascript">
        /// ToolBox zone from which the dock is dragged
        var parentToolBoxZoneID = "";

        function OnClientDragStart(dock, args)
        {
            // get a reference to the RadDock HTML element
            var dockElement = dock.get_element();
            //Create a RadDock's clone
            var clonedDock = dock.clone();

            var clonedElement = clonedDock.get_element();

            //Get the ZoneID from which the dock is initially dragged
            parentToolBoxZoneID = clonedDock.get_dockZoneID();

            //Detach the OnClientDragStart handler method from the cloned dock or recursion will occur
            clonedDock.remove_dragStart(OnClientDragStart);

            //Attach the OnClientDragEnd handler method to the DragEnd client-side event
            clonedDock.add_dragEnd(OnClientDragEnd);

            //Set Toolbox zone as a forbidden for the cloned RadDock
            var zones = clonedDock.get_forbiddenZones();
            zones[zones.length] = dock.get_dockZone().get_uniqueName();


            //Hide original RadDock.Once a cloned RadDock starts to drag we shouls show the orignal RadDock
            dockElement.style.display = 'none';

            //Create an event which will change the currently dragged RadDock - it will be cloned RadDock
            var ev = args.ownerEvent;
            var handle = clonedDock.get_handle();
            if (document.createEventObject)
            {
                // create event for IE
                var evt = document.createEventObject();
                evt.clientX = ev.clientX;
                evt.clientY = ev.clientY;
                handle.fireEvent("onmousedown", evt)
            }
            else
            {
                // create event for FF and others
                var evt = document.createEvent("MouseEvents");
                evt.initMouseEvent("mousedown", !ev.cancelBubble, ev.cancelable, ev.view,
             ev.detail, ev.screenX, ev.screenY, ev.clientX, ev.clientY,
             ev.ctrlKey, ev.altKey, ev.shiftKey, ev.metaKey,
             ev.button, null);
                handle.dispatchEvent(evt);
            }

            //Show original RadDock
            dockElement.style.display = '';
            //Hack: a placeholder stays visible so we should hide it programatically
            dock.get_dockZone().hidePlaceholder();
            args.set_cancel(true);
        }

        function OnClientDragEnd(dock, args)
        {
            //If the dock is not dropped at allowed position 
            //(must be in a zone different than the toolbox zones) it should be disposed
            if (dock.get_dockZoneID() == parentToolBoxZoneID)
            {
                destroyDock(dock);
            }
            else
            {
                dock.remove_dragEnd(OnClientDragEnd);
            }
        }

        function destroyDock(dock)
        {
            //Always dispose of this dock - it was just for temp purposes
            dock.set_closed(true);
            dock.undock();
            dock.dispose();
        }
    </script>

    </form>
</body>
</html>
